package ru.cleptoman {
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import ru.cleptoman.starling.geom.PixelsBounds;
	import ru.cleptoman.starling.net.ParticleConfigFile;
	import ru.cleptoman.starling.net.STMFileEncoder;
	import starling.core.Starling;
	import starling.display.Sprite;
	import starling.extensions.PDParticleSystem;
	import starling.textures.Texture;
	
	/**
	 * ...
	 * @author Kutov Aleksey aka cleptoman
	 */
	public class StarlingMain extends Sprite implements IStarlingMain{
		
		[Embed(source = "../../assets/drugs.stmf", mimeType = "application/octet-stream")]
		private var EmitterFileBytes:Class;
		
		private var _particles:PDParticleSystem;
		
		public function StarlingMain() {
			super();
			/**
			 * создаем массив байтов файла сеттингсов и сериализуем
			 */
			var file:ParticleConfigFile				= STMFileEncoder.decode(new EmitterFileBytes());
			/**
			 * воссоздаем баитмапдату из натроек файла
			 */
			
			var r:PixelsBounds						= file.pixelsRect;
			var textureSource:BitmapData			= new BitmapData(r.width, r.height, true, 0);
			textureSource.setPixels(new Rectangle(0, 0, r.width, r.height), file.textureBytes);
			/**
			 * создаем текстуру для партиклов
			 */
			var texture:Texture						= Texture.fromBitmapData(textureSource);
			
			/**
			 * PEX конфиг достаем из файлика
			 */
			
			var pex:XML								= new XML(file.configPEXBytes); 
			
			/**
			 * создаем партиклы
			 */
			_particles								= new PDParticleSystem(pex, texture);
			/**
			 * добавляем в старлинговский дисплейлист
			 */
			
			this.addChild(_particles);
			/**
			 * добавляем в текущий джаглер, инстанс класса, в который добавляются экземпляры реализующие интерфейс IAnimatable (MovieClip,PDParticleSystem в том числе)
			 * для того чтобы запустить...ммм...таймлайн добавленного объекта
			 */
			Starling.juggler.add(_particles);
			/**
			 * стартуем в бесконечность. если не добавились в Джаглер, то ничего происходить не будет. любуемся)
			 */
			_particles.start();
		}
		
		/* INTERFACE ru.cleptoman.IStarlingMain */
		
		public function setEmitterPos(x:Number = 0, y:Number = 0):void {
			/**
			 * шевелим эмиттер
			 */
			_particles.emitterX			= x;
			_particles.emitterY			= y;
		}

		
	}

}